﻿namespace ProjectAirFighter.Entities;
/// <summary>
/// Класс-сущность "Истребитель"
/// </summary>
public class EntityAirFighter : EntityWarPlane
{
    /// <summary>
    /// Скорость 
    /// </summary>
    public int Speed { get; private set; }

    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }

    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }

    /// <summary>
    /// Дополнительный цвет
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Признак (опция) наличия ракет
    /// </summary>
    public bool Rocket { get; private set; }

    /// <summary>
    /// Признак (опция) наличия дополнительных крыльев
    /// </summary>
    public bool AdditionalWing { get; private set; }

    /// <summary>
    /// Шаг
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Иницифлизация полей объекта-класса истребителя
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="rocket">Признак наличия рокет</param>
    /// <param name="additionalWing">Признак наличия дополнительных крыльев</param>
    public EntityAirFighter(int speed, double weight, Color bodyColor, Color additionalColor, bool rocket, bool additionalWing) :base(speed, weight, bodyColor)
    {
        
        AdditionalColor = additionalColor;
        Rocket = rocket;
        AdditionalWing = additionalWing;

    }
}


